/* ----------------------------------------------------------------------------
 *        ATAG support for booting Linux
 * ----------------------------------------------------------------------------
 * Copyright (c) 2010, Achim Ehrlich, taskit GmbH
 * 
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification are permitted
 */

#define ATAG_NONE	0x00000000

struct tag_header {
	unsigned int size;
	unsigned int tag;
};

/* The list must start with an ATAG_CORE node */
#define ATAG_CORE	0x54410001

struct tag_core {
	unsigned int flags;		/* bit 0 = read-only */
	unsigned int pagesize;
	unsigned int rootdev;
};

/* it is allowed to have multiple ATAG_MEM nodes */
#define ATAG_MEM	0x54410002

struct tag_mem32 {
	unsigned int	size;
	unsigned int	start;	/* physical start address */
};

extern void Linux_Prepare_Tags(void);


#define tag_size(type)	((sizeof(struct tag_header) + sizeof(struct type)) >> 2)
